/* Borrowed and modified from glibc.  All GPL stuff applies. */

#include <sys/regdef.h>
#include <asm/asm.h>

	.text
NESTED(_mcount, 32, ra)
	.set	noat
	subu	sp, sp, 24
	sw	ra, 0(sp)
	sw	AT, 4(sp)
	sw	a0, 8(sp)
	sw	a1, 12(sp)
	sw	a2, 16(sp)
	sw	a3, 20(sp)
#ifdef _CONFIG_STACKCHECK
#define __NR_ILLEGAL 0xfff
	.set	noreorder
	li   v0, __NR_ILLEGAL
	syscall
	.set	reorder
#ifdef _CONFIG_PROFILING
	lw	ra, 0(sp)
	lw	AT, 4(sp)
#endif	/* _CONFIG_PROFILING */
#endif	/* _CONFIG_STACKCHECK */
#ifdef _CONFIG_PROFILING
	move	a1, ra
	move	a0, AT
	jal	__mcount
/* 	nop */
#endif	/* _CONFIG_PROFILING */
	lw	ra, 0(sp)
	lw	AT, 4(sp)
	lw	a0, 8(sp)
	lw	a1, 12(sp)
	lw	a2, 16(sp)
	lw	a3, 20(sp)
	.set	noreorder
	addu	sp, sp, 24+8	/* mips-gcc puts in subu of 8 before call */
	j	ra
	move	ra, AT		/* restore ra for rest of calling routine */
	.set	reorder
	.set	at
END(_mcount)
