/* JL: Language Define
 *  0: Japanese
 *  1: German
 *  2: ChineseTrad
 *  3: English
 *  4: ChineseSimp
**/  
#define MAX_LANGUAGE 1
#ifdef VAR
int gnLanguageIndex = 0;

char *gbszUnused[MAX_LANGUAGE]={ 
        "Unused",
};
char *gbszUnavailable[MAX_LANGUAGE]={ 
        "Unavailable",
};
char *gbszPPPConnected[MAX_LANGUAGE]={ 
        "PPP Connected",
};
char *gbszPPPConnecting[MAX_LANGUAGE]={ 
        "PPP Connecting",
};
char *gbszPPPDisconnecting[MAX_LANGUAGE]={
        "PPP Disconnecting",
};
char *gbszPPPDisconnected[MAX_LANGUAGE]={ 
        "PPP Disconnected",
};
char *gbszPPPTimeOut[MAX_LANGUAGE]={ 
        "Time out",
};
char *gbszPPPAuthenticating[MAX_LANGUAGE]={ 
        "PPP Authenticating",
};
char *gbszPPPAuthenFail[MAX_LANGUAGE]={ 
        "PPP Authentication Failure",
};
char *gbszPPPLCPNegotiating[MAX_LANGUAGE]={ 
        "PPP LCP Negotiating",
};
char *gbszPPPLCPFail[MAX_LANGUAGE]={ 
        "PPPLCPFail",
};
char *gbszPPPIPCPNegotiating[MAX_LANGUAGE]={ 
        "PPPIPCP Negotiating",
};
char *gbszPPPIPCPFail[MAX_LANGUAGE]={ 
        "PPPIPCP Fail",
};
char *gszEnable[MAX_LANGUAGE]={
        "Enable",
};
char *gszDisable[MAX_LANGUAGE]={
        "Disable",
};
char *gszSessionName[MAX_LANGUAGE]={
        "Session Name:",
};
char *gszMainSession[MAX_LANGUAGE]={
        "Main Session",
};
char *gszBackupSession[MAX_LANGUAGE]={
        "Backup Session",
};
char *gszNoSelected[MAX_LANGUAGE]={
        "No Selected Session",
};
char *gszSub1Session[MAX_LANGUAGE]={
        "Sub 1 Session",
};
char *gszSub2Session[MAX_LANGUAGE]={
        "Sub 2 Session",
};
char *gszallSession[MAX_LANGUAGE]={
        "*",
};
char *gsz1and2Session[MAX_LANGUAGE]={
        "1&2",
};
char *gsz1and3Session[MAX_LANGUAGE]={
        "1&3",
};
char *gsz2and3Session[MAX_LANGUAGE]={
        "2&3",
};
char *gszISPNumber[MAX_LANGUAGE]={
        "ISP Number:",
};
char *gszISPName[MAX_LANGUAGE]={
        "ISP Name:",
};
char *gszWANType[MAX_LANGUAGE]={
        "WAN Type:",
};
char *gszPPPoE[MAX_LANGUAGE]={ 
        "PPPoE",
};
char *gszPPPoEUnnumber[MAX_LANGUAGE]={
        "PPPoE Unnumberred",
};
char *gszDHCP[MAX_LANGUAGE]={
        "DHCP",
};
char *gszStaticIP[MAX_LANGUAGE]={
        "STATIC IP",
};
char *gszWANIPAddress[MAX_LANGUAGE]={
        "WAN IP Address:",
};
char *gszWANGateway[MAX_LANGUAGE]={
        "WAN Gateway:",
};
char *gszPrimaryDNS[MAX_LANGUAGE]={
        "Primary DNS:",
};
char *gszSecondaryDNS[MAX_LANGUAGE]={
        "Secondary DNS:",
};
char *gszWANNetmask[MAX_LANGUAGE]={
        "WAN Netmask:",
};
char *gszWANEthernetStatus[MAX_LANGUAGE]={
        "WAN Ethernet Status",
};
char *gszLANEthernetStatus[MAX_LANGUAGE]={
        "LAN Ethernet Status",
};
char *gszMAC[MAX_LANGUAGE]={
        "MAC",
};
char *gszMTU[MAX_LANGUAGE]={
        "MTU",
};
char *gszRXpackets[MAX_LANGUAGE]={
        "RX packets",
};
char *gszTXpackets[MAX_LANGUAGE]={
        "TX packets",
};
char *gszRXbytes[MAX_LANGUAGE]={
        "RX bytes",
};
char *gszTXbytes[MAX_LANGUAGE]={
        "TX bytes",
};
char *gszWirelessStatus[MAX_LANGUAGE]={
        "Wireless Status",
};
char *gszNoWirelessCardFound[MAX_LANGUAGE]={
        "No Wireless Card Found",
};
char *gszWirelessRegionInconsistent[MAX_LANGUAGE]={
        "Wireless region inconsistent with PCMCIA card",
};
char *gszType[MAX_LANGUAGE]={
        "Type",
};
char *gszESSID[MAX_LANGUAGE]={
        "ESSID",
};
char *gszChannel[MAX_LANGUAGE]={
        "Channel",
};
char *gszRTSThreshold[MAX_LANGUAGE]={
        "RTS Threshold",
};
char *gszFragmentThreshold[MAX_LANGUAGE]={
        "Fragment Threshold",
};
char *gszWEPEncryption[MAX_LANGUAGE]={
        "WEP Encryption",
};
char *gszARPTable[MAX_LANGUAGE]={
        "ARP Table",
};
char *gszDHCPLeaseTable[MAX_LANGUAGE]={
        "DHCP Lease Table",
};
char *gszRoutingTable[MAX_LANGUAGE]={
        "Routing Table",
};
char *gszClientMAC[MAX_LANGUAGE]={
        "Client MAC",
};
char *gszIPAddress[MAX_LANGUAGE]={
        "IP Address",
};
char *gszMACAddress[MAX_LANGUAGE]={
        "MAC Address",
};
char *gszTTL[MAX_LANGUAGE]={
        "TTL",
};
char *gszexpired[MAX_LANGUAGE]={
        "expired",
};
char *gszoff[MAX_LANGUAGE]={
        "off",
};
char *gszon[MAX_LANGUAGE]={
        "on",
};
char *gaz64bit[MAX_LANGUAGE]={
        " (64 bit)",
};
char *gaz128bit[MAX_LANGUAGE]={
        " (128 bit)",
};
char *gaz152bit[MAX_LANGUAGE]={
        " (152 bit)",
};
char *gszDestination[MAX_LANGUAGE]={
        "Destination",
};
char *gszNetmask[MAX_LANGUAGE]={
        "Netmask",
};
char *gszGetway[MAX_LANGUAGE]={
        "Getway",
};
char *gszMetric[MAX_LANGUAGE]={
        "Metric",
};
char *gszInterface[MAX_LANGUAGE]={
        "Interface",
};
char *gszDefault[MAX_LANGUAGE]={
        "Default",
};
char *gszindefinite[MAX_LANGUAGE]={
        "indefinite",
};
char *gpszConnectionGroup[3]={"PPPoE", "PPP", "DHCP"};
char *gpszConnectionSession[4*MAX_LANGUAGE]={
        "main session", "backup session", "sub1 session", "sub2 session",
};
char *gpszPPPoEAction[7*MAX_LANGUAGE]={
        "PPPoE session begin",
        "PPPoE success",
        "PPPoE fail",
        "PPPoE disconnect for client request",
        "PPPoE disconnect for server request",
        "PPPoE NG",
        "PPPoE session connecting",
};
char *gpszPPPAction[20*MAX_LANGUAGE]={
        "PPP LCP begin",
        "PPP LCP success",
        "PPP LCP fail",
        "PPP PAP authentication success",
        "PPP PAP authentication fail",
        "PPP CHAP authentication success",
        "PPP CHAP authentication fail",
        "PPP IPCP success",
        "PPP IPCP fail",
        "PPP disconnect for client request",
        "PPP disconnect for server request",
        "PPP no ACHO response",
        "PPP NG",
        "PPP IP success",
        "PPP authentication fail",
        "PPP authentication",
        "PPP PAP authentication",
        "PPP CHAP authentication",
        "PPP disconnect by user",
        "PPP disconnect",
};
char *gpszUpnpEvent[8*MAX_LANGUAGE]={
        "add port",
        "add port failed",
        "add port failed (no more area)",
        "port delete",
        "port delete failed",
        "delete all by user",
        "automatic deletion (user timer)",
        "automatic deletion (application timer)",
};
char *gpszPowerOn[MAX_LANGUAGE]={
        "Power On", 
};
char *gpszPrevious[MAX_LANGUAGE]={
        "<<Previous",
};
char *gszEdit[MAX_LANGUAGE]={
	"Edit",
};
char *gszDelete[MAX_LANGUAGE]={
	"Delete",
};
char *gszSmartsetupMsg1[MAX_LANGUAGE]={
        "The GN-B49G has detected the WAN connection is Dynamic IP Address and the setup has completed. The Router is rebooting now.",
};
char *gszSmartsetupMsg3_1[MAX_LANGUAGE]={
        "Settings can be accessed through the control panel and connecting to",
};
char *gszSmartsetupMsg3_2[MAX_LANGUAGE]={
        "and entering the password.  Please refer to the Users Manual for details.",
};
char *gszSmartsetupMsg2_1[MAX_LANGUAGE]={
       "",
};
char *gszSmartsetupMsg2_2[MAX_LANGUAGE]={
       " seconds following router restart, the browser window will automatically close.",
};
char *gszSmartsetupMsg4_1[MAX_LANGUAGE]={
       "The browser will automaticcally connect the Router after ",
};
char *gszSmartsetupMsg4_2[MAX_LANGUAGE]={
       " seconds. If not, you can check the following HTTP address.",
};
char *gszSmartsetupMsg5_1[MAX_LANGUAGE]={
       "IP conflict checked!. LAN IP address has been change to ",
};
char *gszSmartsetupMsg5_2[MAX_LANGUAGE]={
       " to prevent conflict with the WAN IP address, please reconfigure your peer IP address to work with new a LAN IP address.",
};


#else
extern int gnLanguageIndex;
extern char *gbszUnused[MAX_LANGUAGE];
extern char *gbszUnavailable[MAX_LANGUAGE];
extern char *gbszPPPConnected[MAX_LANGUAGE];
extern char *gbszPPPConnecting[MAX_LANGUAGE];
extern char *gbszPPPDisconnecting[MAX_LANGUAGE];
extern char *gbszPPPDisconnected[MAX_LANGUAGE];
extern char *gbszPPPTimeOut[MAX_LANGUAGE];
extern char *gbszPPPAuthenticating[MAX_LANGUAGE];
extern char *gbszPPPAuthenFail[MAX_LANGUAGE];
extern char *gbszPPPLCPNegotiating[MAX_LANGUAGE];
extern char *gbszPPPLCPFail[MAX_LANGUAGE];
extern char *gbszPPPIPCPNegotiating[MAX_LANGUAGE];
extern char *gbszPPPIPCPFail[MAX_LANGUAGE];
extern char *gszEnable[MAX_LANGUAGE];
extern char *gszDisable[MAX_LANGUAGE];
extern char *gszSessionName[MAX_LANGUAGE];
extern char *gszMainSession[MAX_LANGUAGE];
extern char *gszBackupSession[MAX_LANGUAGE];
extern char *gszNoSelected[MAX_LANGUAGE];
extern char *gszSub1Session[MAX_LANGUAGE];
extern char *gszSub2Session[MAX_LANGUAGE];
extern char *gszISPNumber[MAX_LANGUAGE];
extern char *gszISPName[MAX_LANGUAGE];
extern char *gszWANType[MAX_LANGUAGE];
extern char *gszPPPoE[MAX_LANGUAGE];
extern char *gszPPPoEUnnumber[MAX_LANGUAGE];
extern char *gszDHCP[MAX_LANGUAGE];
extern char *gszStaticIP[MAX_LANGUAGE];
extern char *gszWANIPAddress[MAX_LANGUAGE];
extern char *gszWANGateway[MAX_LANGUAGE];
extern char *gszPrimaryDNS[MAX_LANGUAGE];
extern char *gszSecondaryDNS[MAX_LANGUAGE];
extern char *gszWANNetmask[MAX_LANGUAGE];
extern char *gszWANEthernetStatus[MAX_LANGUAGE];
extern char *gszLANEthernetStatus[MAX_LANGUAGE];
extern char *gszMAC[MAX_LANGUAGE];
extern char *gszMTU[MAX_LANGUAGE];
extern char *gszRXpackets[MAX_LANGUAGE];
extern char *gszTXpackets[MAX_LANGUAGE];
extern char *gszRXbytes[MAX_LANGUAGE];
extern char *gszTXbytes[MAX_LANGUAGE];
extern char *gszWirelessStatus[MAX_LANGUAGE];
extern char *gszNoWirelessCardFound[MAX_LANGUAGE];
extern char *gszWirelessRegionInconsistent[MAX_LANGUAGE];
extern char *gszType[MAX_LANGUAGE];
extern char *gszESSID[MAX_LANGUAGE];
extern char *gszChannel[MAX_LANGUAGE];
extern char *gszRTSThreshold[MAX_LANGUAGE];
extern char *gszFragmentThreshold[MAX_LANGUAGE];
extern char *gszWEPEncryption[MAX_LANGUAGE];
extern char *gszARPTable[MAX_LANGUAGE];
extern char *gszDHCPLeaseTable[MAX_LANGUAGE];
extern char *gszRoutingTable[MAX_LANGUAGE];
extern char *gszClientMAC[MAX_LANGUAGE];
extern char *gszIPAddress[MAX_LANGUAGE];
extern char *gszMACAddress[MAX_LANGUAGE];
extern char *gszTTL[MAX_LANGUAGE];
extern char *gszexpired[MAX_LANGUAGE];
extern char *gszoff[MAX_LANGUAGE];
extern char *gszon[MAX_LANGUAGE];
extern char *gaz64bit[MAX_LANGUAGE];
extern char *gaz128bit[MAX_LANGUAGE];
extern char *gaz152bit[MAX_LANGUAGE];
extern char *gszDestination[MAX_LANGUAGE];
extern char *gszNetmask[MAX_LANGUAGE];
extern char *gszGetway[MAX_LANGUAGE];
extern char *gszMetric[MAX_LANGUAGE];
extern char *gszInterface[MAX_LANGUAGE];
extern char *gszDefault[MAX_LANGUAGE];
extern char *gszindefinite[MAX_LANGUAGE];
extern char *gpszConnectionGroup[3];
extern char *gpszConnectionSession[4*MAX_LANGUAGE];
extern char *gpszPPPoEAction[7*MAX_LANGUAGE];
extern char *gpszPPPAction[20*MAX_LANGUAGE];
extern char *gpszUpnpEvent[8*MAX_LANGUAGE];
extern char *gpszPowerOn[MAX_LANGUAGE];
extern char *gpszPrevious[MAX_LANGUAGE];
extern char *gszEdit[MAX_LANGUAGE];
extern char *gszDelete[MAX_LANGUAGE];
extern char *gszSmartsetupMsg1[MAX_LANGUAGE];
extern char *gszSmartsetupMsg2_1[MAX_LANGUAGE];
extern char *gszSmartsetupMsg2_2[MAX_LANGUAGE];
extern char *gszSmartsetupMsg3_1[MAX_LANGUAGE];
extern char *gszSmartsetupMsg3_2[MAX_LANGUAGE];
extern char *gszSmartsetupMsg4_1[MAX_LANGUAGE];
extern char *gszSmartsetupMsg4_2[MAX_LANGUAGE];
extern char *gszSmartsetupMsg5_1[MAX_LANGUAGE];
extern char *gszSmartsetupMsg5_2[MAX_LANGUAGE];
#endif

