/*	$Id: dma_bcopy.h,v 1.1.1.1 2004/04/29 09:54:07 jkglee Exp $	*/
/*
 * dma_bcopy.h - Definitions for BRECIS DMA copy engine. User API portion.
 */

#define	COPYDEV	"/dev/bcopy"


/*
 * The IOCTL number of IOCTL calls
 */

#define	BRECIS_COPY_CTL	('C' << 8 | 0x0001)


/*
 * The operation is specified in the cpy_ioctl struct.
 */

typedef struct cpy_ioctl
{
	int	mode;	/* Transfer mode - same as hardware */
	unsigned int	length;
	void	*src;
	void	*dest;
} cpy_ioctl;


/*	End of dma_bcopy.h	*/
